// Copyright (c) 2005 - 2017 Settlers Freaks (sf-team at siedler25.org)
//
// This file is part of Return To The Roots.
//
// Return To The Roots is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 2 of the License, or
// (at your option) any later version.
//
// Return To The Roots is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Return To The Roots. If not, see <http://www.gnu.org/licenses/>.

#ifndef Identity_h__
#define Identity_h__

/// Returns the argument of type T unchanged
template<typename T>
struct Identity
{
    typedef T result_type;

    result_type operator()(const result_type& arg) { return arg; }

    template<typename T_Unused>
    result_type operator()(const result_type& arg, const T_Unused&)
    {
        return arg;
    }
};

#endif // Identity_h__
